diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/test/wifi-mlo-test.cc ns-3.38/src/wifi/test/wifi-mlo-test.cc
--- ns-3.37/src/wifi/test/wifi-mlo-test.cc	2022-11-01 17:37:24.763395800 -0700
+++ ns-3.38/src/wifi/test/wifi-mlo-test.cc	2023-03-16 20:54:23.872869300 -0700
@@ -799,71 +2505,149 @@
 WifiMultiLinkOperationsTestSuite::WifiMultiLinkOperationsTestSuite()
     : TestSuite("wifi-mlo", UNIT)
 {
+    using ParamsTuple =
+        std::tuple<std::vector<std::string>,                 // non-AP MLD channels
+                   std::vector<std::string>,                 // AP MLD channels
+                   std::vector<std::pair<uint8_t, uint8_t>>, // (STA link ID, AP link ID) of setup
+                                                             // links
+                   std::vector<uint8_t>>; // IDs of link that cannot change PHY band
+
     AddTestCase(new GetRnrLinkInfoTest(), TestCase::QUICK);
-    // matching channels: setup all links
-    AddTestCase(new MultiLinkSetupTest(
-                    {"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
-                    {"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
-                    {{0, 0}, {1, 1}, {2, 2}}),
-                TestCase::QUICK);
-    // non-matching channels, matching PHY bands: setup all links
-    AddTestCase(new MultiLinkSetupTest(
-                    {"{108, 0, BAND_5GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
-                    {"{36, 0, BAND_5GHZ, 0}", "{120, 0, BAND_5GHZ, 0}", "{5, 0, BAND_6GHZ, 0}"},
-                    {{1, 0}, {0, 1}, {2, 2}}),
-                TestCase::QUICK);
-    // non-AP MLD switches band on some links to setup 3 links
-    AddTestCase(new MultiLinkSetupTest(
-                    {"{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{36, 0, BAND_5GHZ, 0}"},
-                    {"{36, 0, BAND_5GHZ, 0}", "{9, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                    {{2, 0}, {0, 1}, {1, 2}}),
-                TestCase::QUICK);
-    // the first link of the non-AP MLD cannot change PHY band and no AP is operating on
-    // that band, hence only 2 links are setup
-    AddTestCase(new MultiLinkSetupTest(
-                    {"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{8, 20, BAND_2_4GHZ, 0}"},
-                    {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                    {{1, 0}, {2, 1}},
-                    {0}),
-                TestCase::QUICK);
-    // the first link of the non-AP MLD cannot change PHY band and no AP is operating on
-    // that band; the second link of the non-AP MLD cannot change PHY band and there is
-    // an AP operating on the same channel; hence 2 links are setup
-    AddTestCase(new MultiLinkSetupTest(
-                    {"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{8, 20, BAND_2_4GHZ, 0}"},
-                    {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                    {{1, 0}, {2, 1}},
-                    {0, 1}),
-                TestCase::QUICK);
-    // the first link of the non-AP MLD cannot change PHY band and no AP is operating on
-    // that band; the second link of the non-AP MLD cannot change PHY band and there is
-    // an AP operating on the same channel; the third link of the non-AP MLD cannot
-    // change PHY band and there is an AP operating on the same band (different channel);
-    // hence 2 links are setup by switching channel (not band) on the third link
-    AddTestCase(new MultiLinkSetupTest(
-                    {"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{60, 0, BAND_5GHZ, 0}"},
-                    {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                    {{1, 0}, {2, 2}},
-                    {0, 1, 2}),
-                TestCase::QUICK);
-    // non-AP MLD has only two STAs and setups two links
-    AddTestCase(new MultiLinkSetupTest(
-                    {"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}"},
-                    {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                    {{0, 1}, {1, 0}}),
-                TestCase::QUICK);
-    // single link non-AP STA associates with an AP affiliated with an AP MLD
-    AddTestCase(new MultiLinkSetupTest(
-                    {"{120, 0, BAND_5GHZ, 0}"},
-                    {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                    {{0, 2}}),
-                TestCase::QUICK);
-    // a STA affiliated with a non-AP MLD associates with a single link AP
-    AddTestCase(new MultiLinkSetupTest(
-                    {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                    {"{120, 0, BAND_5GHZ, 0}"},
-                    {{2, 0}}),
-                TestCase::QUICK);
+
+    for (const auto& [staChannels, apChannels, setupLinks, fixedPhyBands] :
+         {// matching channels: setup all links
+          ParamsTuple({"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
+                      {"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
+                      {{0, 0}, {1, 1}, {2, 2}},
+                      {}),
+          // non-matching channels, matching PHY bands: setup all links
+          ParamsTuple({"{108, 0, BAND_5GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
+                      {"{36, 0, BAND_5GHZ, 0}", "{120, 0, BAND_5GHZ, 0}", "{5, 0, BAND_6GHZ, 0}"},
+                      {{1, 0}, {0, 1}, {2, 2}},
+                      {}),
+          // non-AP MLD switches band on some links to setup 3 links
+          ParamsTuple({"{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{36, 0, BAND_5GHZ, 0}"},
+                      {"{36, 0, BAND_5GHZ, 0}", "{9, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+                      {{2, 0}, {0, 1}, {1, 2}},
+                      {}),
+          // the first link of the non-AP MLD cannot change PHY band and no AP is operating on
+          // that band, hence only 2 links are setup
+          ParamsTuple(
+              {"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{8, 20, BAND_2_4GHZ, 0}"},
+              {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+              {{1, 0}, {2, 1}},
+              {0}),
+          // the first link of the non-AP MLD cannot change PHY band and no AP is operating on
+          // that band; the second link of the non-AP MLD cannot change PHY band and there is
+          // an AP operating on the same channel; hence 2 links are setup
+          ParamsTuple(
+              {"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{8, 20, BAND_2_4GHZ, 0}"},
+              {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+              {{1, 0}, {2, 1}},
+              {0, 1}),
+          // the first link of the non-AP MLD cannot change PHY band and no AP is operating on
+          // that band; the second link of the non-AP MLD cannot change PHY band and there is
+          // an AP operating on the same channel; the third link of the non-AP MLD cannot
+          // change PHY band and there is an AP operating on the same band (different channel);
+          // hence 2 links are setup by switching channel (not band) on the third link
+          ParamsTuple({"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{60, 0, BAND_5GHZ, 0}"},
+                      {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+                      {{1, 0}, {2, 2}},
+                      {0, 1, 2}),
+          // the first link of the non-AP MLD cannot change PHY band and no AP is operating on
+          // that band; the second link of the non-AP MLD cannot change PHY band and there is
+          // an AP operating on the same channel; hence one link only is setup
+          ParamsTuple({"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}"},
+                      {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+                      {{1, 0}},
+                      {0, 1}),
+          // non-AP MLD has only two STAs and setups two links
+          ParamsTuple({"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}"},
+                      {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+                      {{0, 1}, {1, 0}},
+                      {}),
+          // single link non-AP STA associates with an AP affiliated with an AP MLD
+          ParamsTuple({"{120, 0, BAND_5GHZ, 0}"},
+                      {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+                      {{0, 2}},
+                      {}),
+          // a STA affiliated with a non-AP MLD associates with a single link AP
+          ParamsTuple({"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+                      {"{120, 0, BAND_5GHZ, 0}"},
+                      {{2, 0}},
+                      {})})
+    {
+        AddTestCase(new MultiLinkSetupTest(staChannels, apChannels, setupLinks, fixedPhyBands),
+                    TestCase::QUICK);
+
+        for (const auto& trafficPattern : {WifiTrafficPattern::STA_TO_STA,
+                                           WifiTrafficPattern::STA_TO_AP,
+                                           WifiTrafficPattern::AP_TO_STA,
+                                           WifiTrafficPattern::AP_TO_BCAST,
+                                           WifiTrafficPattern::STA_TO_BCAST})
+        {
+            // No Block Ack agreement
+            AddTestCase(new MultiLinkTxTest(trafficPattern,
+                                            WifiBaEnabled::NO,
+                                            WifiUseBarAfterMissedBa::NO,
+                                            1,
+                                            staChannels,
+                                            apChannels,
+                                            fixedPhyBands),
+                        TestCase::QUICK);
+            for (const auto& useBarAfterMissedBa :
+                 {WifiUseBarAfterMissedBa::YES, WifiUseBarAfterMissedBa::NO})
+            {
+                // Block Ack agreement with nMaxInflight=1
+                AddTestCase(new MultiLinkTxTest(trafficPattern,
+                                                WifiBaEnabled::YES,
+                                                useBarAfterMissedBa,
+                                                1,
+                                                staChannels,
+                                                apChannels,
+                                                fixedPhyBands),
+                            TestCase::QUICK);
+                // Block Ack agreement with nMaxInflight=2
+                AddTestCase(new MultiLinkTxTest(trafficPattern,
+                                                WifiBaEnabled::YES,
+                                                useBarAfterMissedBa,
+                                                2,
+                                                staChannels,
+                                                apChannels,
+                                                fixedPhyBands),
+                            TestCase::QUICK);
+            }
+        }
+
+        for (const auto& muTrafficPattern : {WifiMuTrafficPattern::DL_MU_BAR_BA_SEQUENCE,
+                                             WifiMuTrafficPattern::DL_MU_MU_BAR,
+                                             WifiMuTrafficPattern::DL_MU_AGGR_MU_BAR,
+                                             WifiMuTrafficPattern::UL_MU})
+        {
+            for (const auto& useBarAfterMissedBa :
+                 {WifiUseBarAfterMissedBa::YES, WifiUseBarAfterMissedBa::NO})
+            {
+                // Block Ack agreement with nMaxInflight=1
+                AddTestCase(new MultiLinkMuTxTest(muTrafficPattern,
+                                                  useBarAfterMissedBa,
+                                                  1,
+                                                  staChannels,
+                                                  apChannels,
+                                                  fixedPhyBands),
+                            TestCase::QUICK);
+                // Block Ack agreement with nMaxInflight=2
+                AddTestCase(new MultiLinkMuTxTest(muTrafficPattern,
+                                                  useBarAfterMissedBa,
+                                                  2,
+                                                  staChannels,
+                                                  apChannels,
+                                                  fixedPhyBands),
+                            TestCase::QUICK);
+            }
+        }
+    }
+
+    AddTestCase(new ReleaseSeqNoAfterCtsTimeoutTest(), TestCase::QUICK);
 }
 
 static WifiMultiLinkOperationsTestSuite g_wifiMultiLinkOperationsTestSuite; ///< the test suite
